#include <stdio.h>
#include <iLBC_encode.h>
#include <iLBC_define.h>

#define ILBC_FIX_MODE 20
#define ILBCNOOFWORDS_MAX   (NO_OF_BYTES_30MS/2)
short encode( /* (o) Number of bytes encoded */
iLBC_Enc_Inst_t *iLBCenc_inst,
/* (i/o) Encoder instance */
short *encoded_data, /* (o) The encoded bytes */
short *data /* (i) The signal block to encode*/
) {
	float block[BLOCKL_MAX];
	int k;

	/* convert signal to float */
	for (k = 0; k < iLBCenc_inst->blockl; k++)
		block[k] = (float) data[k];

	/* do the actual encoding */
	iLBC_encode((unsigned char *) encoded_data, block, iLBCenc_inst);

	return (iLBCenc_inst->no_of_bytes);
}
int main(int argc, char *argv[]) {

	printf("encode start\n");
	FILE *ifileid, *efileid;
	short data[BLOCKL_MAX];
	short encoded_data[ILBCNOOFWORDS_MAX];
	int len;
	int blockcount = 0;
	if (argc != 3)
	{
		fprintf(stderr,"Wrong parameter: decode Ilbc_file_in PCM_file_out\n");
		exit(-1);
	}
	if ((ifileid = fopen(argv[1], "rb")) == NULL) {
			fprintf(stderr, "Cannot open input file %s\n", argv[2]);
			exit(2);
	}
	if ((efileid = fopen(argv[2], "wb")) == NULL) {
			fprintf(stderr, "Cannot open encoded file %s\n", argv[3]);
			exit(1);
	}
	/* Create structs */
	iLBC_Enc_Inst_t Enc_Inst;
	initEncode(&Enc_Inst, ILBC_FIX_MODE);
	while (fread(data, sizeof(short), Enc_Inst.blockl, ifileid)
				== Enc_Inst.blockl) {
			blockcount++;
			len = encode(&Enc_Inst, encoded_data, data);
			fwrite(encoded_data, sizeof(unsigned char), len, efileid);
	}
	fclose(ifileid);
	fclose(efileid);
	return 0;
}
